
String inStr = "";                        // Приемник информации от Nextion.
bool serialReadFlag = false;              // Регулировщик приемника информации от Nextion.

String tt, tt1;
//float  ttt1;
//int ttt;
void setup() {  
  Serial.begin(9600);	
  //Serial.begin(115200);

	}

void loop() {   
  if (Serial.available()) {
   uint8_t inn = Serial.read();           // Читаем один байт.    
   if(serialReadFlag) {                   // Если установлен флаг приема - действуем.
    if(inn == 59){                        // ASCII : ";" - Находим конец передачи ";". 
      checkCommand(inStr);                // В этой функции будем парсить сообщение.
	    serialReadFlag = false;             // Сбрасываем флаг приема.  
	    }
    else {                                // А это нормальный прием.
	    inStr += (char)inn;                 // Создаем String от Nextion.
	    inStr.trim();                       // Это можно удалить, просто для ручной настройки,а там возникает перевод строки.
	    }
    }
   else {                                 // А здесь отлавливается начало передачи от Nextion.      
	   if(inn == 35 ) {                     // ASCII : "#" - Находим начало передачи "#". 
	   serialReadFlag = true;               // После # начинаем чтение при следующем заходе.
	   inStr = "";                          // Но до этого очистим стринг приема.
	    }
    }
  }   
}


void checkCommand(String ins) {                    
  String first = ins.substring(0,1);          // У нас информация от Nextion состоит из двух частей, первая буква - идентификатор действия ловим его: 
  String last  = ins.substring(1);            // А все остальное - данные:
  
   if(first == "n") {                         //'n'  ASCII Value: 110 где, 'n' - идентификатор ячейки памяти.Остальное парсим на float. 
    int ttt = last.toFloat();                 // Получаем текст и переводим в целое число.
      
    tt = (String)(ttt);                       // Преобразуем число в текст. 
    printNextion(tt.c_str(),"Temp10", "0");   // Передаем в Nextion на 0 страницу в поле Temp10.    
   }  
	 if(first == "d") {                         // 'd'  ASCII Value: 100 'd' - идентификатор данных.Остальное парсим на float.    
    float ttt1 = last.toFloat();              // Получаем текст и переводим в число с плавающей запятой.
      
    tt1 = (String)(ttt1);                     // Преобразуем число в текст. 
    printNextion(tt1.c_str(),"Dat0", "0");    // Передаем в Nextion на 0 страницу в поле Temp10.   
	 }      
	 if(first == "k") {                         // 'k'  ASCII Value: 107 'k' - идентификатор нажатия кнопок.Остальное парсим на float.  
    int ttt = last.toFloat();                 // Получаем текст и переводим в целое число.
      
    tt = (String)(ttt);                       // Преобразуем число в текст 
    printNextion(tt.c_str(),"Temp10", "0");   // Передаем в Nextion на 0 страницу в поле Temp10
	 }   
}

void printNextion(const char* data, String top, String page){
  String spage = "page"+page+"."+top+".txt=\"";
  Serial.print(spage);
  Serial.print(data);
  Serial.print("\"");
  Serial.write(0xFF);
  Serial.write(0xFF);
  Serial.write(0xFF);
}



